package function.builtin.special;

import function.*;
import function.builtin.EVAL;
import sexpression.*;

public class OR extends LispFunction {

    private ArgumentValidator argumentValidator;

    public OR() {
        this.argumentValidator = new ArgumentValidator("OR");
    }

    public SExpression call(Cons argumentList) {
        argumentValidator.validate(argumentList);

        return callTailRecursive(argumentList);
    }

    private SExpression callTailRecursive(Cons argumentList) {
        SExpression currentValue = EVAL.eval(argumentList.getCar());
        Cons remainingValues = (Cons) argumentList.getCdr();

        if (remainingValues.nullp() || !currentValue.nullp())
            return currentValue;

        return callTailRecursive(remainingValues);
    }

    public boolean evaluateArguments() {
        return false;
    }

}
